#!/bin/bash
#################################################
# enregistrement_domaine.sh
#################################################

. /usr/bin/ParseDico
. /usr/share/eole/FonctionsEoleNg

/usr/bin/wbinfo -t &> /dev/null
if [ $? -eq 0 ];then
    Question "Le serveur est déjà intégré à un domaine
Voulez-vous relancer l'intégration ?"
    [ $? -ne 0 ] && exit 0
fi

#redemarrage de samba
echo "*** Redémarrage des services pour l'enregistrement au domaine ***"
ntpdate -u $serveur_ntp > /dev/null
/usr/sbin/invoke-rc.d winbind stop > /dev/null
/usr/sbin/invoke-rc.d samba restart > /dev/null
/usr/sbin/invoke-rc.d winbind start > /dev/null

#inscription de la station dans un domaine
echo
echo "Entrer le nom de l'administrateur du serveur Windows :"
read user_admin
echo "Entrer le mot de passe de l'administrateur du serveur Windows :"
read -s mdp_admin
/usr/bin/net ads join -I $ip_serveur_krb -U $user_admin%$mdp_admin
echo

#redemarrage de samba
echo "*** Redémarrage des services pour confirmer l'enregistrement au domaine ***"
ntpdate -u $serveur_ntp > /dev/null
/usr/sbin/invoke-rc.d winbind stop > /dev/null
/usr/sbin/invoke-rc.d samba restart > /dev/null
/usr/sbin/invoke-rc.d winbind start > /dev/null


#test de l'intégration
/usr/bin/wbinfo -t &> /dev/null
if [ $? -eq 1 ]; then
    EchoRouge "L'intégration au domaine a échoué"
else
    EchoVert "L'intégration au domaine a réussi"
fi
